unit Unit2;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
Function GAMMLN(xx:real):real;
PROCEDURE GCF(VAR GAMMCF:real; A:real; X:real; var GLN:real);
procedure GSER(VAR GAMSER:REAL;A:real;X:REAL;VAR GLN:REAL);
Function GAMMP(A,X:REAL):REAL;
Function GAMMQ(A,X:REAL):REAL;
Function ERFC(X:real):real;

implementation
Function GAMMLN(xx:real):real;
CONST
  STP=2.50662827465; HALF=0.5; ONE=1.0; FPF=5.5;
var
  x,tmp,ser:double;
  j:integer;
  cof:array[1..6] of double;
BEGIN
  COF[1]:=76.18009173;      COF[2]:=-86.50532033;
  COF[3]:=24.01409822;      COF[4]:=-1.231739516;
  COF[5]:= 0.120858003e-2;  COF[6]:=-0.536382e-5;
  X:=XX-ONE;
  TMP:=X+FPF;
  TMP:=(X+HALF)*Ln(TMP)-TMP;
  SER:=ONE;
  For J:=1 To 6 do
    BEGIN
      X:=X+ONE;
      SER:=SER+COF[J]/X
    END;
  GAMMLN:=TMP+Ln(STP*SER);
end;

PROCEDURE GCF(VAR GAMMCF:real; A:real; X:real; var GLN:real);
label 1;
const
  ITMAX=100;    EPS=0.0000003;
var
  N:integer; GOLD,G,FAC,B1,B0,ANF,ANA,AN,A1,A0:real;
begin
  GLN:=GAMMLN(A);
  GOLD:=0;
  A0:=1;
  A1:=X;
  B0:=0;
  B1:=1;
  FAC:=1;
  For N:=1 To ITMAX do
  begin
    AN:=N;
    ANA:=AN - A;
    A0:=(A1 + A0 * ANA)* FAC;
    B0:=(B1 + B0 * ANA)* FAC;
    ANF:=AN * FAC;
    A1:=X * A0 + ANF * A1;
    B1:=X * B0 + ANF * B1;
    If A1 <> 0 Then
    begin
      FAC:=1 / A1;
      G:=B1 * FAC;
      If Abs((G - GOLD)/ G)< EPS Then GoTo 1;
      GOLD:=G;
    end
  end;
  ShowMessage('A too large, ITMAX too small');
1: GAMMCF:=Exp(-X + A * Ln(X)- GLN)* G;
end;

procedure GSER(VAR GAMSER:REAL;A:real;X:REAL;VAR GLN:REAL);
label 1;
CONST
  ITMAX=100;    EPS=0.3E-6;
VAR
  N:Integer;
  SUM,DEL,AP:Real;
begin
  GLN:=GAMMLN(A);
  If X <= 0 Then
    If X < 0 Then
      begin
        ShowMessage('棺X<0˳');
        goto 1;
      end
  else
    begin
      GAMSER:=0;
      goto 1;
    end;
  AP:=A;
  Sum:=1 / A;
  DEL:=Sum;
  For N:=1 To ITMAX do
    begin
      AP:=AP + 1;
      DEL:=DEL * X / AP;
      Sum:=Sum + DEL;
      If Abs(DEL) < Abs(Sum) * EPS Then GoTo 1;
    end;
  ShowMessage('A too large, ITMAX too small');
1: GAMSER:=Sum * Exp(-X + A * Ln(X) - GLN);
end;

Function GAMMP(A,X:REAL):REAL;
VAR
  GAMMCF,GLN:REAL;
BEGIN
    If (X < 0) Or (A <= 0) Then  ShowMessage('PAUSE');
    If X < A + 1 Then
      begin
        GSER(GAMMCF, A, X, GLN);
        GAMMP:=GAMMCF;
      end
    Else
      begin
        GCF(GAMMCF, A, X, GLN);
        GAMMP:= 1 - GAMMCF;
      end;
END;

Function GAMMQ(A,X:REAL):REAL;
VAR
  GAMSER,GLN:REAL;
BEGIN
    If (X < 0) Or (A <= 0) Then  ShowMessage('PAUSE');
    If X < A + 1 Then
      begin
        GSER(GAMSER, A, X, GLN);
        GAMMQ:=1-GAMSER;
      end
    Else
      begin
        GCF(GAMSER, A, X, GLN);
        GAMMQ:=GAMSER;
      end;
END;

Function ERFC(X:real):real;
begin
    If X < 0 Then
        ERFC:=1+GAMMP(0.5, sqr(X))
    Else
        ERFC:=GAMMQ(0.5, sqr(X));
end;

end.
