unit Unit2;

interface
Function BESSJ1(X:real):real;
Function BESSY1(X:real):real;

implementation
Function BESSJ1(X:real):real;
var
    AAA,BBB,CCC,AX,Z,Y,XX,SGN:real;
const
    R1 = 72362614232;         R2 = -7895059235;
    R3 = 242396853.1;         R4 = -2972611.439;
    R5 = 15704.4826;          R6 = -30.16036606;
    S1 = 144725228442;        S2 = 2300535178;
    S3 = 18583304.74;         S4 = 99447.43394;
    S5 = 376.9991397;         S6 = 1;
    P1 = 1;                   P2 = 0.00183105;
    P3 = -0.3516396496e-4;    P4 = 0.000002457520174;
    P5 = -0.240337019e-6;
    Q1 = 0.04687499995;       Q2 = -0.2002690873e-3;
    Q3 = 0.8449199096e-5;     Q4 = -0.88228987e-6;
    Q5 = 0.105787412e-6;
begin
    If Abs(X) < 8 Then
    begin
        Y:=X * X;
        AAA:=R1 + Y * (R2 + Y * (R3 + Y * (R4 + Y * (R5 + Y * R6))));
        BBB:=S1 + Y * (S2 + Y * (S3 + Y * (S4 + Y * (S5 + Y * S6))));
        BESSJ1:=X * AAA / BBB;
    end
    Else
    begin
        AX:=Abs(X);
        Z:=8 / AX;
        Y:=Z * Z;
        XX:=AX - 2.356194491;
        AAA:=P1 + Y * (P2 + Y * (P3 + Y * (P4 + Y * P5)));
        BBB:=Q1 + Y * (Q2 + Y * (Q3 + Y * (Q4 + Y * Q5)));
        CCC:=Sqrt(0.636619772 / AX);
        if X > 0 Then
          SGN:= 1
        Else
          SGN:= -1;
        BESSJ1:=CCC * (Cos(XX) * AAA - Z * Sin(XX) * BBB * Sgn);
    end;
end;

Function BESSY1(X:real):real;
var
    AAA,BBB,CCC,Z,Y,XX:real;
const
    P1 = 1;                    P2 = 0.183105e-2;
    P3 = -0.3516396496e-4;     P4 = 0.2457520174e-5;
    P5 = -0.240337019e-6;
    Q1 = 0.04687499995;        Q2 = -0.2002690873e-3;
    Q3 = 0.8449199096e-5;      Q4 = -0.88228987e-6;
    Q5 = 0.105787412e-6;
    R1 = -4.900604943e12;      R2 = 1.27527439e12;
    R3 = -5.153438139e10;      R4 = 7.349264551e8;
    R5 = -4237922.726;         R6 = 8511.937935;
    S1 = 2.49958057e13;        S2 = 4.244419664e11;
    S3 = 3.733650367e9;        S4 = 2.245904002e7;
    S5 = 102042.605;           S6 = 354.9632885;
    S7 = 1;
begin
    If X < 8 Then
    begin
        Y:= X * X;
        AAA:=R1 + Y * (R2 + Y * (R3 + Y * (R4 + Y * (R5 + Y * R6))));
        BBB:=S4 + Y * (S5 + Y * (S6 + Y * S7));
        BBB:=S1 + Y * (S2 + Y * (S3 + Y * BBB));
        CCC:=BESSJ1(X) * Ln(X) - 1/ X;
        BESSY1:=X * AAA / BBB + 0.636619772 * CCC;
    end
    Else
    begin
        Z:=8 / X;
        Y:=Z * Z;
        XX:=X - 2.356194491;
        AAA:=Sqrt(0.636619772 / X);
        BBB:=P1 + Y * (P2 + Y * (P3 + Y * (P4 + Y * P5)));
        CCC:=Q1 + Y * (Q2 + Y * (Q3 + Y * (Q4 + Y * Q5)));
        BESSY1:=AAA * (Sin(XX) * BBB + Z * Cos(XX) * CCC);
    end;
end;

end.
 