unit Unit2;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, UNIT1,Controls, Forms, Dialogs;
Function BESSJ0(X:real):real;
Function BESSJ1(X:real):real;
Procedure ZBRAK(X1, X2:real; N:integer;
                        var XB1, XB2:array of real;var NB:integer);
Function RTSAFE(X1, X2, XACC:real):real;

implementation
Function BESSJ0(X:real):real;
var
   AAA,BBB,CCC,Y,AX,Z,DDD,EEE,XX:real;
const
  P1=1;                    P2=-0.001098628627;
  P3=0.2734510407e-4;      P4=-0.2073370639e-5;
  P5=2.093887211E-07;
  Q1=-0.1562499995e-1;     Q2=0.1430488765e-3;
  Q3=-0.6911147651e-5;     Q4=7.621095161E-07;
  Q5=-9.34945152E-08;
  R1=57568490574;          R2=-13362590354;
  R3=651619640.7;          R4=-11214424.18;
  R5=77392.33017;          R6=-184.9052456;
  S1=57568490411;          S2=1029532985;
  S3=9494680.718;          S4=59272.64853;
  S5=267.8532712;          S6=1;
begin
  If Abs(X) < 8 Then
    begin
      Y:=X * X;
      BBB:=Y* (R4+ Y* (R5+ Y* R6));
      AAA:=R1+ Y* (R2+ Y* (R3+ BBB));
      CCC:=Y* (S3+ Y* (S4+ Y* (S5+ Y* S6)));
      BESSJ0:= AAA / (S1+ Y* (S2+ CCC));
    end
  Else
    begin
      AX:=Abs(X);
      Z:=8/ AX;
      Y:=Z* Z;
      XX:= AX- 0.785398164;
      CCC:=Y* (P3+ Y* (P4+ Y* P5));
      AAA:=P1+ Y* (P2+ CCC);
      DDD:=Y* (Q3+ Y* (Q4+ Y* Q5));
      EEE:=Z* Sin(XX) * (Q1+ Y* (Q2+ DDD));
      BESSJ0:= Sqrt(0.636619772 / AX) * (Cos(XX) * AAA- EEE);
    End;
End;

Function BESSJ1(X:real):real;
VAR
    AAA,BBB,CCC,AX,Z,Y,XX,SGN:real;
const
    R1 = 72362614232;         R2 = -7895059235;
    R3 = 242396853.1;         R4 = -2972611.439;
    R5 = 15704.4826;          R6 = -30.16036606;
    S1 = 144725228442;        S2 = 2300535178;
    S3 = 18583304.74;         S4 = 99447.43394;
    S5 = 376.9991397;         S6 = 1;
    P1 = 1;                   P2 = 0.00183105;
    P3 = -0.3516396496e-4;    P4 = 0.000002457520174;
    P5 = -0.240337019e-6;
    Q1 = 0.04687499995;       Q2 = -0.2002690873e-3;
    Q3 = 0.8449199096e-5;     Q4 = -0.88228987e-6;
    Q5 = 0.105787412e-6;
begin
    If Abs(X) < 8 Then
      begin
        Y:=X * X;
        AAA:=R1 + Y * (R2 + Y * (R3 + Y * (R4 + Y * (R5 + Y * R6))));
        BBB:=S1 + Y * (S2 + Y * (S3 + Y * (S4 + Y * (S5 + Y * S6))));
        BESSJ1:=X * AAA / BBB;
      end
    Else
      begin
        AX:=Abs(X);
        Z:=8 / AX;
        Y:=Z * Z;
        XX:=AX - 2.356194491;
        AAA:=P1 + Y * (P2 + Y * (P3 + Y * (P4 + Y * P5)));
        BBB:=Q1 + Y * (Q2 + Y * (Q3 + Y * (Q4 + Y * Q5)));
        CCC:=Sqrt(0.636619772 / AX);
        if X > 0 THEN
          SGN:= 1
        ELSE
          SGN:= -1;
        BESSJ1:=CCC * (Cos(XX) * AAA - Z * Sin(XX) * BBB * Sgn);
      End;
End;

Procedure ZBRAK(X1, X2:real; N:integer;
                        var XB1, XB2:array of real;var NB:integer);
var
    NBB,I:integer;   X,DX,FP,FC:real;
begin
    NBB:=NB;
    NB:=0;
    X:=X1;
    DX:=(X2 - X1) / N;
    FP:=FUN(X);
    For I:=1 To N do
    begin
        X:=X + DX;
        FC:=FUN(X);
        If FC * FP < 0  Then
        begin
            NB:=NB + 1;
            XB1[NB]:=X - DX;
            XB2[NB]:=X;
        end;
        FP:=FC;
        If NBB = NB Then Exit;
    end; 
end;

Function RTSAFE(X1, X2, XACC:real):real;
Label 99;
var
    J,MAXIT:integer;
    FL,FH,F,XL,XH,SWAP,DX,DF,DXOLD,RTS,DUM,TEMP:real;
begin
    MAXIT:=100;
    FUND(X1, FL, DF);
    FUND(X2, FH, DF);
    If FL * FH >= 0 Then ShowMessage('root must be bracketed');
    If FL < 0 Then
    begin
        XL:=X1;
        XH:=X2;
    end
    Else
    begin
        XH:=X1;
        XL:=X2;
        SWAP:=FL;
        FL:=FH;
        FH:=SWAP;
    end;
    RTS:=0.5 * (X1 + X2);
    DXOLD:=Abs(X2 - X1);
    DX:=DXOLD;
    FUND(RTS, F, DF);
    For J:=1 To MAXIT do
    begin
        DUM:=(RTS - XH) * DF - F * ((RTS - XL) * DF - F);
        If (DUM >= 0) Or (Abs(2 * F) > Abs(DXOLD * DF)) Then
        begin
            DXOLD:=DX;
            DX:=0.5 * (XH - XL);
            RTS:=XL + DX;
            If XL = RTS Then goto 99;
        end
        Else
        begin
            DXOLD:=DX;
            DX:=F / DF;
            TEMP:=RTS;
            RTS:=RTS - DX;
            If TEMP = RTS Then goto 99;
        end;
        If Abs(DX) < XACC Then goto 99;
        FUND(RTS, F, DF);
        If F < 0 Then
        begin
            XL:=RTS;
            FL:=F;
        end
        Else
        begin
            XH:=RTS;
            FH:=F;
        end;
    end; 
    ShowMessage('RTSAFE exceeding maximum iterations.');
99: RTSAFE:=RTS;
end;

end.
